// VideoUpdate.cpp: implementation of the CVideoUpdate class.
//
//////////////////////////////////////////////////////////////////////

#include "engine.h"
#include "../main.h"
#include "VideoUpdate.h"

// include the Direct3D Library file
#ifdef WIN32
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
LPDIRECT3DDEVICE9 d3ddev;    // the pointer to the device class
#endif //WIN32
CMMPointer<Dator<int> > CVideoUpdate::screenWidth=0;
CMMPointer<Dator<int> > CVideoUpdate::screenHeight=0;
CMMPointer<Dator<int> > CVideoUpdate::screenBPP=0;
int CVideoUpdate::scrWidth=640;
int CVideoUpdate::scrHeight=480;
int CVideoUpdate::scrBPP=16;

#ifdef WIN32
CVideoUpdate::CVideoUpdate()
{
	d3d = Direct3DCreate9(D3D_SDK_VERSION);

	D3DPRESENT_PARAMETERS d3dpp;
	D3DDISPLAYMODE d3ddm;
	d3d->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm);

	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = true;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.hDeviceWindow = hWnd;
	//d3dpp.BackBufferFormat = d3ddm.Format;
	d3dpp.BackBufferFormat = D3DFMT_A8R8G8B8;
	d3dpp.BackBufferWidth = scrWidth;
	d3dpp.BackBufferHeight = scrHeight;


	// create a device class using this information and the info from the d3dpp stuct
	d3d->CreateDevice(D3DADAPTER_DEFAULT,
										D3DDEVTYPE_HAL,
										hWnd,
										D3DCREATE_SOFTWARE_VERTEXPROCESSING,
										&d3dpp,
										&d3ddev);

	    // Turn on alpha-blending
    d3ddev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
    // Set the render state up for source alpha blending.
    d3ddev->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
    d3ddev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
    // Get the alpha information solely from the texture.
    d3ddev->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
    d3ddev->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
}

CVideoUpdate::~CVideoUpdate()
{
    if (d3ddev != NULL) d3ddev->Release();
    if (d3d != NULL) d3d->Release();
}

bool CVideoUpdate::Start()
{
	assert(screenWidth && screenHeight && screenBPP);
/*
	if(-1==SDL_InitSubSystem(SDL_INIT_VIDEO))
	{
		CLog::Get().Write(LOG_CLIENT,IDS_GENERIC_SUB_INIT_FAIL,"Video",SDL_GetError());
		return false;
	}
	SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	int flags = SDL_OPENGL | SDL_ANYFORMAT | SDL_FULLSCREEN;

	if(!SDL_SetVideoMode(scrWidth, scrHeight, scrBPP, flags))
	{
		CLog::Get().Write(LOG_CLIENT, IDS_BAD_DISPLAYMODE, scrWidth, scrHeight, scrBPP, SDL_GetError());
		return false;
	}

	//hide the mouse cursor
	SDL_ShowCursor(SDL_DISABLE);
*/
    d3ddev->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_COLORVALUE(0.0f, 0.4f, 1.0f, 1.0f), 1.0f, 0);

    d3ddev->BeginScene();    // begins the 3D scene

		return true;
}

void CVideoUpdate::Update()
{
	// end frame
	d3ddev->EndScene();
	d3ddev->Present(NULL, NULL, NULL, NULL);

	// start new frame
	d3ddev->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_COLORVALUE(0.0f, 0.4f, 1.0f, 1.0f), 1.0f, 0);
	d3ddev->BeginScene();
}

void CVideoUpdate::Stop()
{
//	SDL_QuitSubSystem(SDL_INIT_VIDEO);
}
#endif // WIN32
